require 'httparty'
module E4z
  class ApiClient
    include HTTParty
    dev = 'http://nlp-playground-137981.nitrousapp.com:3000/'
    prod = 'http://eezee.org'
    base_uri prod

    def initialize(token)
      @token = token
    end

    def find_project_by_github_slug(github_slug)
       self.class.get("/projects/find.json", options(by: 'github_full_name', value: github_slug))
    end

    def get_instruction(project_id, instruction_id)
      self.class.get("/projects/#{project_id}/instructions/#{instruction_id}", options)
    end

    def update_instruction(project_id, instruction_id, body)
      self.class.patch("/projects/#{project_id}/instructions/#{instruction_id}", options({}, body))
    end

    def options(params={}, body={})
      {query: {github_token: @token}.merge(params), body: body}
    end
  end
end