require 'pusher-client'

module E4z
  class SocketClient
    def initialize(project_slug)
      @project_slug = project_slug

      socket.subscribe(@project_slug)
      socket[@project_slug].bind('run_instruction') do |data|
        yield(data)
      end

      socket.connect
    end

    def options
      { secure: true }
    end

    def socket
      @socket ||= PusherClient::Socket.new(ENV['PUSHER_TOKEN'], options)
    end
  end
end